"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommandInfo = exports.CommandInfoDecoratorMetadata = void 0;
const Utils_1 = require("../Utils");
class CommandInfoDecoratorMetadata {
    constructor() {
        this.storage = [];
    }
    add(command, description, lang = null, scope) {
        this.storage.push({
            lang,
            command,
            description,
            scope: (scope !== null && scope !== void 0 ? scope : { type: "default" })
        });
    }
    implement(cmdList) {
        let initLanguage = cmdList.getLang();
        let initScope = cmdList.getScope();
        for (let cmd of this.storage) {
            cmdList.setLanguage(cmd.lang);
            cmdList.setScope(cmd.scope.type, Utils_1.ObjectUtils.filterObjectByKey(cmd.scope, k => k !== "type"));
            cmdList.add(cmd.command, cmd.description);
        }
        cmdList.setLanguage(initLanguage);
        cmdList.setScope(initScope.type, Utils_1.ObjectUtils.filterObjectByKey(initScope, k => k !== "type"));
    }
}
exports.CommandInfoDecoratorMetadata = CommandInfoDecoratorMetadata;
function CommandInfo(command, descroption, language, scope) {
    return target => {
        if (!target.constructor.prototype.__tgCommandInfo)
            target.constructor.prototype.__tgCommandInfo = new CommandInfoDecoratorMetadata();
        let metadata = target.constructor.prototype.__tgCommandInfo;
        metadata.add(command, descroption, language, scope);
        return target;
    };
}
exports.CommandInfo = CommandInfo;
